package JBMSTours;
import java.lang.Exception;
import JBMSTours.serializabletypes.HotelStay;
import JBMSTours.serializabletypes.CustomerFlight;
import JBMSTours.serializabletypes.Tour;

/**
 * Look at the <a href="../JBMSTours/CityChoiceException.java">Source</a>.<p>
 * The application throws this exception if the requested CustomerObject is not available.
 */


public class AvailabilityException extends Exception
{

	/**
	 * Constructor
	 *
	 */
	public AvailabilityException()
	{
		super();
	}

	/**
	 * Constructor
	 *
	 */
	public AvailabilityException(HotelStay hs)
	{
		super("Sorry, we can't make a HotelStay for you in " + hs.cityName + " because there are no available hotels in your " +
              "tour level (" + Tour.getStringForLevel(hs.level) + ").");
	}

	/**
	 * Constructor
	 *
	 */
	public AvailabilityException(CustomerFlight cs)
	{
		super("Sorry, we can't make a CustomerFlight for you in " + cs.arriveCity.getName() + " because there are no available flights in your " +
              "tour level (" + Tour.getStringForLevel(cs.level) + ").");
	}

	
}

