package JBMSTours;
import java.lang.Exception;
import JBMSTours.serializabletypes.HotelStay;
import JBMSTours.serializabletypes.CustomerFlight;
import JBMSTours.serializabletypes.Tour;

/**
 * Look at the <a href="../JBMSTours/CityChoiceException.java">Source</a>.<p>
 * The application throws this exception if the proposed customer object is out of the customer's
 * budget.
 */


public class BudgetException extends Exception
{

	/**
	 * Constructor
	 *
	 */
	public BudgetException()
	{
		super();
	}

	/**
	 * Constructor
	 *
	 */
	public BudgetException(HotelStay hs)
	{
		super("Sorry, we can't make a HotelStay for you in " + hs.cityName + " because all the available hotels in your " +
              "tour level (" + Tour.getStringForLevel(hs.level) + ") exceed your budget.");
	}

	/**
	 * Constructor
	 *
	 */
	public BudgetException(CustomerFlight cs)
	{
		super("Sorry, we can't make a CustomerFlight for you from " +
			  cs.departCity.getName() +
			  " to " + cs.arriveCity.getName() +
			  " because all the available hotels in your " +
              "tour level (" + Tour.getStringForLevel(cs.level) + ") exceed your budget.");
	}

	
}

