package JBMSTours;
import java.util.Hashtable;
import java.sql.Date;
import JBMSTours.serializabletypes.Person;
import JBMSTours.serializabletypes.Adult;
import JBMSTours.serializabletypes.Child;

/**
 * This class initializes a hash table of people and group data. The
 * main application gets the data out of this class instead of from
 * a user. A real application would get it from a user.
 * The pre-built version of the database uses values 80 and over.
 * Otherwise, BuildATour uses values 1-79.
 *
 */
public class CustomerData {

    private java.util.Hashtable peopleData;
    private int value;
    private int keystart;
    private static final int INCREMENTVALUE = 20;

  public CustomerData() {
    peopleData = new Hashtable();
    value = 0;
    keystart = 0;

  }



  public CustomerData(boolean prebuild) {
        peopleData = new Hashtable();

	if (!prebuild) {
    value = 0;
    keystart=0;
    peopleData.put(new Integer(1), new Adult("Janet", "Java"));
    peopleData.put(new Integer(2), new Date(63, 2, 9));
    peopleData.put(new Integer(3), "ABC-DE-FGHX");
    peopleData.put(new Integer(4), new Adult("John", "Java"));
    peopleData.put(new Integer(5), new Date(65, 6, 9));
    peopleData.put(new Integer(6), new Child("Junior", "Java"));
    peopleData.put(new Integer(7), new Date(97, 0, 12));
    peopleData.put(new Integer(8), "1335 Main St.");
    peopleData.put(new Integer(9), "010-335-9996");
    peopleData.put(new Integer(10), new Integer(76));
    peopleData.put(new Integer(11), new Integer(39));
    peopleData.put(new Integer(12), new Integer(31));
    peopleData.put(new Integer(13), new Integer(5));
    peopleData.put(new Integer(14), new Integer(11));
    peopleData.put(new Integer(15), new Integer(19));
    peopleData.put(new Integer(16), "economy");
    peopleData.put(new Integer(17), new Double(10000.00));


    peopleData.put(new Integer(21), new Adult("Jenny", "Jabeemess"));
    peopleData.put(new Integer(22), new Date(64, 7, 22));
    peopleData.put(new Integer(23), "ABC-DE-FGHI");
    peopleData.put(new Integer(24), new Adult("Peter", "Jabeemess"));
    peopleData.put(new Integer(25), new Date(62, 10, 9));
    peopleData.put(new Integer(26), new Child("Jim", "Jabeemess"));
    peopleData.put(new Integer(27), new Date(97, 1, 15));
    peopleData.put(new Integer(28), "1702 Haight St.");
    peopleData.put(new Integer(29), "415-001-7796");
    peopleData.put(new Integer(30), new Integer(84));
    peopleData.put(new Integer(31), new Integer(40));
    peopleData.put(new Integer(32), new Integer(41));
    peopleData.put(new Integer(33), new Integer(12));
    peopleData.put(new Integer(34), new Integer(25));
    peopleData.put(new Integer(35), new Integer(30));
    peopleData.put(new Integer(36), "first class");
    peopleData.put(new Integer(37), new Double(20000.00));



    peopleData.put(new Integer(41), new Adult("Julie", "Smith"));
    peopleData.put(new Integer(42), new Date(70, 0, 31));
    peopleData.put(new Integer(43), "ABC-EE-FGHI");
    peopleData.put(new Integer(44), new Adult("Paul", "Smith"));
    peopleData.put(new Integer(45), new Date(72, 5, 3));
    peopleData.put(new Integer(46), new Child("J.J.", "Smith"));
    peopleData.put(new Integer(47), new Date(94, 10, 15));
    peopleData.put(new Integer(48), "500 Adelaide Ave.");
    peopleData.put(new Integer(49), "88-335-9006");
    peopleData.put(new Integer(50), new Integer(46));
    peopleData.put(new Integer(51), new Integer(65));
    peopleData.put(new Integer(52), new Integer(49));
    peopleData.put(new Integer(53), new Integer(25));
    peopleData.put(new Integer(54), new Integer(35));
    peopleData.put(new Integer(55), new Integer(45));
    peopleData.put(new Integer(56), "standard");
    peopleData.put(new Integer(57), new Double(15000.00));



    peopleData.put(new Integer(61), new Adult("Julie", "Thibaut"));
    peopleData.put(new Integer(62), new Date(60, 1, 27));
    peopleData.put(new Integer(63), "ABC-FE-FGHI");
    peopleData.put(new Integer(64), new Adult("Paul", "Thibaut"));
    peopleData.put(new Integer(65), new Date(57, 5, 25));
    peopleData.put(new Integer(66), new Child("Catherine", "Thibaut"));
    peopleData.put(new Integer(67), new Date(97, 0, 1));
    peopleData.put(new Integer(68), "500 Champs Elysees");
    peopleData.put(new Integer(69), "889-35-0006");
    peopleData.put(new Integer(70), new Integer(35));
    peopleData.put(new Integer(71), new Integer(11));
    peopleData.put(new Integer(72), new Integer(32));
    peopleData.put(new Integer(73), new Integer(2));
    peopleData.put(new Integer(74), new Integer(10));
    peopleData.put(new Integer(75), new Integer(18));
    peopleData.put(new Integer(76), "first class");
    peopleData.put(new Integer(77), new Double(20000.00));

	}


	else {
    value = 80;
    keystart = 80;

    peopleData.put(new Integer(81), new Adult("Cathy", "Cafe"));
    peopleData.put(new Integer(82), new Date(63, 1, 9));
    peopleData.put(new Integer(83), "ABC-DE-FGHI");
    peopleData.put(new Integer(84), new Adult("Curt", "Cafe"));
    peopleData.put(new Integer(85), new Date(63, 0, 5));
    peopleData.put(new Integer(86), new Child("Carl", "Cafe"));
    peopleData.put(new Integer(87), new Date(96, 10, 4));
    peopleData.put(new Integer(88), "1555 Oak Ave.");
    peopleData.put(new Integer(89), "010-055-0555");
    peopleData.put(new Integer(90), new Integer(76));
    peopleData.put(new Integer(91), new Integer(39));
    peopleData.put(new Integer(92), new Integer(31));
    peopleData.put(new Integer(93), new Integer(5));
    peopleData.put(new Integer(94), new Integer(11));
    peopleData.put(new Integer(95), new Integer(19));
    peopleData.put(new Integer(96), "economy");
    peopleData.put(new Integer(97), new Double(10000.00));


    peopleData.put(new Integer(101), new Adult("Gwen", "Garcia"));
    peopleData.put(new Integer(102), new Date(62, 11, 15));
    peopleData.put(new Integer(103), "CBC-DE-FGHI");
    peopleData.put(new Integer(104), new Adult("Greg", "Garcia"));
    peopleData.put(new Integer(105), new Date(62, 4, 1));
    peopleData.put(new Integer(106), new Child("Sylvia", "Garcia"));
    peopleData.put(new Integer(107), new Date(96, 5, 13));
    peopleData.put(new Integer(108), "111 Ashbury St.");
    peopleData.put(new Integer(109), "415-000-7779");
    peopleData.put(new Integer(110), new Integer(84));
    peopleData.put(new Integer(111), new Integer(40));
    peopleData.put(new Integer(112), new Integer(41));
    peopleData.put(new Integer(113), new Integer(12));
    peopleData.put(new Integer(114), new Integer(25));
    peopleData.put(new Integer(115), new Integer(30));
    peopleData.put(new Integer(116), "first class");
    peopleData.put(new Integer(117), new Double(20000.00));


    peopleData.put(new Integer(121), new Adult("Julie", "Jones"));
    peopleData.put(new Integer(122), new Date(62, 11, 1));
    peopleData.put(new Integer(123), "ABD-DE-FGHK");
    peopleData.put(new Integer(124), new Adult("Paul", "Jones"));
    peopleData.put(new Integer(125), new Date(62, 3, 30));
    peopleData.put(new Integer(126), new Child("Hank", "Jones"));
    peopleData.put(new Integer(127), new Date(94, 5, 3));
    peopleData.put(new Integer(128), "555 Meryton Ave.");
    peopleData.put(new Integer(129), "55-003-4452");
    peopleData.put(new Integer(130), new Integer(46));
    peopleData.put(new Integer(131), new Integer(65));
    peopleData.put(new Integer(132), new Integer(49));
    peopleData.put(new Integer(133), new Integer(25));
    peopleData.put(new Integer(134), new Integer(35));
    peopleData.put(new Integer(135), new Integer(45));
    peopleData.put(new Integer(136), "standard");
    peopleData.put(new Integer(137), new Double(15000.00));


    peopleData.put(new Integer(141), new Adult("Charlotte", "Leon"));
    peopleData.put(new Integer(142), new Date(62, 10, 1));
    peopleData.put(new Integer(143), "MMC-KE-FGHI");
    peopleData.put(new Integer(144), new Adult("Paul", "Leon"));
    peopleData.put(new Integer(145), new Date(62, 3, 4));
    peopleData.put(new Integer(146), new Child("Andre", "Leon"));
    peopleData.put(new Integer(147), new Date(97, 1, 5));
    peopleData.put(new Integer(148), "45 Rue du Quai Voltaire");
    peopleData.put(new Integer(149), "889-00-555");
    peopleData.put(new Integer(150), new Integer(35));
    peopleData.put(new Integer(151), new Integer(11));
    peopleData.put(new Integer(152), new Integer(32));
    peopleData.put(new Integer(153), new Integer(2));
    peopleData.put(new Integer(154), new Integer(10));
    peopleData.put(new Integer(155), new Integer(18));
    peopleData.put(new Integer(156), "first class");
    peopleData.put(new Integer(157), new Double(20000.00));
	}
  }


    /**
     * Gets the next object in the hash table.
     *
     * @return Object
     */   

  private Object getNextObject(int i) {

  return peopleData.get(new Integer(i + 1));

  }

    /**
     * Gets the next object in the hash table as an int.
     *
     * @return int
     */   

  private int getNextObjectAsInt(int i) {

  return ((Integer) peopleData.get(new Integer(i + 1))).intValue();

  }

    /**
     * Gets the next object in the hash table as a String.
     *
     * @return String
     */   

  private String getNextObjectAsString(int i) {

  return (String) peopleData.get(new Integer(i + 1));

  }

    /**
     * Gets the next object in the hash table as a double.
     *
     * @return double
     */   

  private double getNextObjectAsDouble(int i) {

  return ((Double) peopleData.get(new Integer(i + 1))).doubleValue();

  }

	/**
     * Gets the next object in the hash table as a Date.
     *
     * @return Date
     */   

  private Date getNextObjectAsDate(int i) {

  return (Date) peopleData.get(new Integer(i + 1));

  }

    /**
     * Gets the main Adult object out of  hash table.
     *
     * @param  int    integer of the next available id for the main person
     *
     * @return Adult
     */   

  public Adult getPrimaryAdult() {

  Adult a = (Adult) getNextObject(keystart);
 
  a.setBirthdate(getNextObjectAsDate(keystart + 1));
  a.setPassportNumber(getNextObjectAsString(keystart+2));
  return a; 
  }

    /**
     * Gets the secondary Adult object out of  hash table.
     *
     * @param  int    integer of the next available id for the main person
     *
     * @return Adult
     */   

  public Adult getSecondaryAdult() {
  
  Adult a = (Adult) getNextObject(keystart+3);
  a.setBirthdate(getNextObjectAsDate(keystart+4));
  return a;
  }

    /**
     * Gets the Child object out of  hash table.
     *
     * @param  int    integer of the next available id for the main person
     *
     * @return Adult
     */   


  public Child getChild(int pid) {
  Child c = (Child) getNextObject(keystart+5);
  c.setBirthdate(getNextObjectAsDate(keystart+6));
  c.setParent(pid);
  return c;
  }

    /**
     * Gets the id of the group's home city out of  hash table.
     *
     *
     * @return int
     */   

  public int getCity1ID() {
  int i = getNextObjectAsInt(keystart + 9); 
  return i;

  }

    /**
     * Gets the id of the group's first city out of  hash table.
     *
     *
     * @return int
     */   

  public int getCity2ID() {
  int i = getNextObjectAsInt(keystart + 10); 
  return i;
  }

    /**
     * Gets the id of the group's second city out of  hash table.
     *
     *
     * @return int
     */   

  public int getCity3ID() {
  int i = getNextObjectAsInt(keystart + 11); 
  return i;
  }

    /**
     * Gets the int representing the group's first travel date
     * out of  hash table.
     *
     *
     * @return int
     */   

  public int getDay1() {
  int i = getNextObjectAsInt(keystart + 12); 
  return i;
  }

    /**
     * Gets the int representing the group's second travel date
     * out of  hash table.
     *
     * @return int
     */   

  public int getDay2() {
  int i = getNextObjectAsInt(keystart + 13); 
  return i;
  }

    /**
     * Gets the int representing the group's third travel date
     * out of  hash table.
     *
     *
     * @return int
     */   


  public int getDay3() {
  int i = getNextObjectAsInt(keystart + 14); 
  return i;
  }

    /**
     * Gets the String address of group
     * out of  hash table.
     *
     *
     * @return String
     */   


  public String getAddress() {
  return getNextObjectAsString(keystart + 7);

  }

    /**
     * Gets the String phone number of group
     * out of  hash table.
     *
     *
     * @return String
     */   
  public String getPhone() {
  return getNextObjectAsString(keystart + 8);

  }

    /**
     * Gets the String level  of group
     * out of  hash table.
     *
     *
     * @return String
     */   
  public String getLevel() {
  return getNextObjectAsString(keystart + 15);

  }
    /**
     * Gets the double budget of group
     * out of  hash table.
     *
     *
     * @return double
     */   

  public double getBudget() {
  
  return getNextObjectAsDouble(keystart+16);


  }



    /**
     * gets the starting key value
     * (0 or 80, depending on the mode, plus the incrementation for the number
     * of groups already stored)
     *
     */   

  public void setKeyStart(int i) {
  i = i -1;
  
      if (i < 4 )
         keystart= value + (i*INCREMENTVALUE);
 
      if (i >= 4 && i < 8)

        keystart= value + ((i - 4)*INCREMENTVALUE);
  
  else

     keystart= value + ((i % 4) * INCREMENTVALUE);
  
  }



}



