package JBMSTours;

import java.util.Date;

/**
 * This class helps with testing the JBMSTours application.  It allows
 * one to set a date as the current date, so the caller can control
 * what the current date is.  The output of the application depends on
 * the current date - by controlling it, we can ensure the application
 * prints the same output every time.
 */
public class TourDate extends Date {

    static boolean nowIsSet = false;
    static long pseudoNow = 0;

    /**
     * Calling this method sets the current date to the given date.
     *
     * @param now   The current date in milliseconds since Jan. 1, 1970 00:00:00
     */
    public static void setNow(long now) {
        pseudoNow = now;
        nowIsSet = true;
    }

    /**
     * Constructor for a TourDate.  This form of the constructor gives the
     * current date.  If setNow() has been called, it constructs the date
     * that was given to setNow().
     */
    public TourDate() {
        super();

        if (nowIsSet)
            this.setTime(pseudoNow);
    }

    /**
     * Constructor for a TourDate.
     *
     * @param date  The number of milliseconds since Jan. 1, 1970 00:00:00
     */
    public TourDate(long date) {
        super(date);
    }
}
