package JBMSTours.applets;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.sql.DriverManager;
import java.sql.Connection;
import java.sql.Statement;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.io.StringBufferInputStream;
import java.io.ByteArrayOutputStream;
import COM.cloudscape.util.JDBCDisplayUtil;

/**
 * This sample program is a minimal applet showing
 * JDBC access to Cloudscape running on the server. It runs queries and display
 * corresponding results.
 *
 * This applet uses classes from client.jar and tools.jar. To run it, the Web server
 * must be able to find the main Cloudscape library, client.jar, and tools.jar.
 *
 *
 * @author Francois and Janet
 */
public class ClientApplet extends Applet {
	
	boolean isStandalone = false;
	ByteArrayOutputStream aByteOutStream =
	new ByteArrayOutputStream();
	PrintStream thePrintStream = new PrintStream(aByteOutStream);
	private boolean firstTime = true;
	
	Panel northPanel = new Panel();
	Button button1 = new Button();
	Panel centerPanel = new Panel();
	TextArea queryTextArea = new TextArea();
	TextArea resultTextArea = new TextArea();
	Panel southPanel = new Panel();
	BorderLayout borderLayout1 = new BorderLayout();
	BorderLayout borderLayout2 = new BorderLayout();
	BorderLayout borderLayout3 = new BorderLayout();
	BorderLayout borderLayout4 = new BorderLayout();
	TextField statusField = new TextField();
	
	Connection conn;
	Statement stmt;
	
	//Get a parameter value
	public String getParameter(String key, String def) {
		return isStandalone ? System.getProperty(key, def) :
			(getParameter(key) != null ? getParameter(key) : def);
	}
	
	//Construct the applet
	public ClientApplet() {
	}
	
	//Initialize the applet
	public void start() {
		setFont(new Font("Courier", Font.PLAIN, 16));
		repaint();
		try { jbInit(); } catch (Exception e) { e.printStackTrace(); }
	}
	
	//Component initialization
	private void jbInit() throws Exception {
		this.setSize(new Dimension(600, 427));
		statusField.setBackground(Color.gray);
		southPanel.setLayout(borderLayout4);
		northPanel.setLayout(borderLayout3);
		northPanel.setBackground(Color.white);
		button1.setLabel("Execute Statement");
		button1.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(ActionEvent e) {
				button1_actionPerformed(e);
			}
		}
								  );
		centerPanel.setLayout(borderLayout2);
		this.setLayout(borderLayout1);
		this.add(northPanel, BorderLayout.NORTH);
		northPanel.add(button1, BorderLayout.WEST);
		this.add(centerPanel, BorderLayout.CENTER);
		centerPanel.add(queryTextArea, BorderLayout.CENTER);
		centerPanel.add(resultTextArea, BorderLayout.SOUTH);
		this.add(southPanel, BorderLayout.SOUTH);
		southPanel.add(statusField, BorderLayout.NORTH);
		statusField.setEditable(false);
		
		// connect to Cloudscape
		try {
			this.connectToCloudscape();
		} catch (Throwable ex) {
			handleException((Throwable)ex);
		}
	}
	
	// connect to Cloudscape running in Cloudconnect
	private void connectToCloudscape() throws Exception {
		
		// Load the appropriate JDBC driver
		resultTextArea.setText("Loading Client JDBC Driver ...\n");
		
		Class.forName("COM.cloudscape.core.WebLogicDriver").newInstance();
		
		resultTextArea.append("Connecting to Cloudscape...\n");
		
		
		String DBConnectionURL = getParameter("DBConnectionURL");
		resultTextArea.append("DBConnectionURL is " + DBConnectionURL);
		if (DBConnectionURL == null) {
		resultTextArea.append("ERROR: No Connection URL passed in for connecting Cloudscape...\n");
		resultTextArea.append("ERROR: Aborting...");
		return;
		}
		
		
		// do actual Cloudscape  connection
		conn = DriverManager.getConnection(DBConnectionURL);
		
		if (conn != null) {
			resultTextArea.append("Successfully Connected to Cloudscape...\n\n");
			resultTextArea.append("Click on <Execute Statement> button to run the query...");
		} else {
			resultTextArea.append("ERROR: Failed to connect to Cloudscape...\n");
			return;
		}
		
		// we were successfull, then display first statement to be executed
		// in the query panel (as a sample statement query)
		//
		queryTextArea.setText("SELECT city.getLocation().toString() " +
                                      "FROM Cities WHERE city.getName() = 'San Francisco'");
	}
	
	//Get Applet information
	public String getAppletInfo() {
		return "ClientApplet";
	}
	
	//Get parameter info
	public String[][] getParameterInfo() {
		return null;
	}
	
	/**
	 * Close JDBC connection in the <tt>stop()</tt>
	 * method.
	 */
	public void stop() {
		try {
			if (conn != null)
				conn.close();
		} catch (Throwable ex) {
			handleException((Throwable)ex);
		}
	}
	
	public void paint(Graphics g){
		if (firstTime) {
			g.drawString ("Loading Client Applet...."+
						  " and connecting to Cloudscape", 10, 200
							 );
			repaint();
			firstTime = false;
		}
	}
	
	public static void main(String[] args) {
		Applet applet = new ClientApplet();
		applet.setVisible(true);
		applet.init();
	}
	
	void button1_actionPerformed(ActionEvent e) {
		// send user statement to Cloudscape
		try {
			resultTextArea.setText("Sending Statement to Cloudscape...\n");
			long startTime = System.currentTimeMillis();
			
			// Create a Statement
			stmt = conn.createStatement();
			
			// send query statement to Cloudscape
			stmt.execute(queryTextArea.getText());
			
			resultTextArea.append("Processing results...\n");
			// reset byte stream
			aByteOutStream.reset();
			
			JDBCDisplayUtil.DisplayResults(thePrintStream,
										   stmt,
										   conn
										   );
			// display results in text result area
			thePrintStream.flush();
			resultTextArea.setText(aByteOutStream.toString());
			
			// we can close the statement now
			stmt.close();
			
			long endTime = System.currentTimeMillis();
			
			// stop statistics for this statement
			statusField.setText(	"Elapsed Time: "+
									(endTime - startTime) + " msecs");
			
			queryTextArea.selectAll(); 
			
		} catch (Throwable ex) {
			handleException((Throwable) ex);
		}
	}
	
	void handleException(Throwable ex) {
		
		if (ex instanceof SQLException) {
			printSQLError((SQLException) ex);
		} else {
			resultTextArea.setText(	"Got Non SQL Exception, see "+
									"Java Console for details!"
									);
			printError((Exception) ex);
		}
	}
	
	void printSQLError(SQLException ex) {
		resultTextArea.setText("");
		resultTextArea.append("SQLException thrown:\n");
		while (ex != null) {
			resultTextArea.append("\n");
			resultTextArea.append("*** Exception: \n");
			resultTextArea.append(ex.toString()+"\n");
			ex = ex.getNextException();
		}
	}
	
	void printError(Exception ex) {
		System.out.println("");
		System.out.print("*** Exception: ");
		System.out.println(ex.toString());
		ex.printStackTrace();
	}
}





