package JBMSTours.inserters;

import java.sql.*;
import java.io.IOException;
import JBMSTours.Util;

/**
 * 
 * 
 *
 */
public class InsertJars implements Inserters  {

    private PreparedStatement insert;
    private String insertString;
    private int jarsInserted;
    private static int NUMJARS=1;
    private boolean insertableAsSQL=true;
	private String fullJarName;

    public InsertJars ()   {
        insertString = "CALL dbclasses.addJar('APP', ?, ?)";
        jarsInserted = 0;
    }


    public boolean insert (Connection conn) throws SQLException, Exception {

        // here we prepared the statement once
		if (!prepareStatements(conn))
			return false;
		fullJarName = java.lang.System.getProperty("user.dir") + java.io.File.separator + "tours.jar";
		insert.setString(1, "toursLogic");
		insert.setString(2, fullJarName);
		//a CALL statement does not return a number of rows;
		if (insert.executeUpdate() ==0)
			jarsInserted++;
		Util.println("");
        Util.println(jarsInserted + " jar files stored in database");
        Util.println("");
		insert.close();
        if (jarsInserted == NUMJARS) 
            return true;
	    /* if the wrong number of rows inserted, roll back*/
        else 
			return false;
		
		
		
    }
	
	
	
	public boolean prepareStatements(Connection conn) throws SQLException {
        insert = conn.prepareStatement(insertString);
		if (insert != null) {
			return true;
		}
		return false;
		
	}
	
	
	
    public void confirmInsert (Connection conn) throws SQLException {
		
		
		
		int count = 0;
        PreparedStatement ps = conn.prepareStatement("SELECT \"NAME\".substring(0, \"NAME\".length()-6) " +
													 "AS class_name FROM NEW " +
													 "jarvti(?) AS EQ WHERE eq.\"NAME\" LIKE '%class' "+
													 "ORDER BY class_name");
		Util.println("Files in this jar file include: ");
		ps.setString(1, fullJarName);
		ResultSet rs = ps.executeQuery();
		while (rs.next()) {
			Util.println(rs.getString(1));
		}
		rs.close();
		
    } 
	
    public void extractDataForReInsert (Connection conn) throws SQLException {
		
    }
	
	
	
    public boolean createSQLScript (Connection conn) throws SQLException {
		Util.println(insertString);
		return insertableAsSQL;
		
	}
	
}
